import { SimpleDataSource } from './simple-data-source';
import { Page, PaginationEndpoint, Sort } from './page';
import { Observable } from 'rxjs';
export declare class PaginationDataSource<T, Q = Partial<T>> implements SimpleDataSource<T> {
    private endpoint;
    pageSize: number;
    initialPage: number;
    loading$: Observable<boolean>;
    page$: Observable<Page<T>>;
    private readonly pageNumber;
    private readonly sort;
    private readonly query;
    private readonly loading;
    constructor(endpoint: PaginationEndpoint<T, Q>, initialSort: Sort<T>, initialQuery: Q, pageSize?: number, initialPage?: number);
    sortBy(sort: Partial<Sort<T>>): void;
    queryBy(query: Partial<Q>): void;
    fetch(page: number, pageSize?: number): void;
    connect(): Observable<T[]>;
    disconnect(): void;
}
